/**************************************************************************************************

Copyright (c) 2007-2012   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_menu_bar.h"
#include  <stdio.h>
#include  "mitaka.h"
#include  "mtk_mode.h"
#include  "mtk_switches.h"
#include  "mtk_command.h"
#include  "mtk_text.h"
#include  "mtk_target.h"
#include  "mtk_solar_system.h"
#include  "mtk_planets.h"
#include  "mtk_pbuffer.h"
#include  "mtk_spacecraft.h"
#include  "mtk_movement.h"
#include  "mtk_stereo.h"
#include  "mtk_window_mode.h"
#include  "resource.h"


HMENU       hMenu = NULL;
HMENU       hMenuJ = NULL;
HMENU       hMenuE = NULL;
HMENU		hMenuTimeJ = NULL;
HMENU		hMenuTimeE = NULL;
HMENU		hMenuScaleJ = NULL;
HMENU		hMenuScaleE = NULL;

extern char szLandingPosNameJ[256];
extern char szLandingPosNameE[256];
extern HMENU hMenu, hMenuJ, hMenuE;
extern float FontSize, vFontSize[5];


inline void
set_menu_text(HMENU _hMenu, UINT menu_id, char* text)
{
	MENUITEMINFO  mii;
	mii.cbSize = sizeof(mii);
	mii.fMask = MIIM_TYPE;
	mii.fType = MFT_STRING;
	mii.dwTypeData = text;

	SetMenuItemInfo(_hMenu, menu_id, FALSE, &mii);
}

void
init_menu_bar(HINSTANCE hInstance, HWND hWnd)
{
	//-- j[o[
	hMenuJ = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU_J));
	hMenuE = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU_E));
	// n_
	char text[256];
	sprintf(text, "%s֒(&M)", szLandingPosNameJ);
	set_menu_text(hMenuJ, ID_LANDING_MITAKA, text);
    sprintf(text, "Landing on %s (&M)", szLandingPosNameE);
	set_menu_text(hMenuE, ID_LANDING_MITAKA, text);
	//-- ݒ̃|bvAbvj[
	hMenuTimeJ = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU_TIME_J));
	hMenuTimeJ = GetSubMenu(hMenuTimeJ, 0);
	hMenuTimeE = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU_TIME_E));
	hMenuTimeE = GetSubMenu(hMenuTimeE, 0);
	//-- XP[ݒ̃|bvAbvj[
	hMenuScaleJ = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU_SCALE_J));
	hMenuScaleJ = GetSubMenu(hMenuScaleJ, 0);
	hMenuScaleE = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU_SCALE_E));
	hMenuScaleE = GetSubMenu(hMenuScaleE, 0);
}

void
set_menu_bar(HWND hWnd)
{
	if (get_language() == LANG_ENG)	{ hMenu = hMenuE; }
	else							{ hMenu = hMenuJ; }

	if ( !is_fullscreen_mode() ) {
		SetMenu(hWnd, hMenu);
	}
}

void
destroy_menu_bar()
{
    if (hMenu == hMenuE) {
		if (hMenuJ)	DestroyMenu(hMenuJ);
	} else {
		if (hMenuE)	DestroyMenu(hMenuE);
	}

	DestroyMenu(hMenuTimeJ);
	DestroyMenu(hMenuTimeE);
	DestroyMenu(hMenuScaleJ);
	DestroyMenu(hMenuScaleE);
}

void
EnableMenuBar(HWND hWnd, bool flg)
{
	if (flg) {
		SetMenu(hWnd, hMenu);
	} else {
		SetMenu(hWnd, NULL);
	}
}




void
OnTargetByKey2(const char* key)
{
	if (get_mode() != MODE_3D) return;

	OnTargetByKey(key);
}



bool
process_menu_command(HWND hWnd, int id)
{
	switch (id) {
		//-- FILE
		case ID_FILE_SAVEIMAGE:			OnSaveImage();						return true;
		case ID_FILE_SAVEIMAGE_HIGHRES:	OnSaveImageHighRes();				return true;
		case ID_FILE_EXIT:				SendMessage(hWnd, WM_CLOSE, 0, 0);	return true;
		//-- VIEW
		case ID_VIEW_RESETVIEW:			OnResetView();		return true;
		//-- LAUNCH
		case ID_LAUNCH:
			{
				switch (get_mode()) {
					case MODE_PLANETARIUM:	OnTakeoff();	break;
					case MODE_3D:			OnLanding();	break;
					default:								break;
				}
				return true;
			}
		case ID_LANDING_MITAKA:	OnLandingInit();			return true;
		case ID_LANDING_MODE_HORIZONTAL:	OnLandingMode( LANDING_MODE_HORIZONTAL );	return true;
		case ID_LANDING_MODE_SURFACE_VIEW:	OnLandingMode( LANDING_MODE_SURFACE_VIEW );	return true;
		//-- TARGET
		case ID_GOTO_TARGET:				OnTargetMoveControler();		return true;
		case ID_TARGET_SUN:					OnTargetByKey2("Sun");			return true;
		case ID_TARGET_MERCURY:				OnTargetByKey2("Mercury");		return true;
		case ID_TARGET_VENUS:				OnTargetByKey2("Venus");		return true;
		case ID_TARGET_EARTH:				OnTargetByKey2("Earth");		return true;
		case ID_TARGET_MARS:				OnTargetByKey2("Mars");			return true;
		case ID_TARGET_JUPITER:				OnTargetByKey2("Jupiter");		return true;
		case ID_TARGET_SATURN:				OnTargetByKey2("Saturn");		return true;
		case ID_TARGET_URANUS:				OnTargetByKey2("Uranus");		return true;
		case ID_TARGET_NEPTUNE:				OnTargetByKey2("Neptune");		return true;
		case ID_TARGET_PLUTO:				OnTargetByKey2("Pluto");		return true;
		case ID_TARGET_ERIS:				OnTargetByKey2("SmallBody136199");	return true;
		case ID_TARGET_SEDNA:				OnTargetByKey2("SmallBody90377");	return true;
		case ID_TARGET_MOON:				OnTargetByKey2("Moon");			return true;
		case ID_TARGET_IO:					OnTargetByKey2("Io");			return true;

		case ID_TARGET_PIONEER10:			OnTargetByKey2("Pioneer10");	return true;
		case ID_TARGET_PIONEER11:			OnTargetByKey2("Pioneer11");	return true;
		case ID_TARGET_VOYAGER1:			OnTargetByKey2("VoyagerI");		return true;
		case ID_TARGET_VOYAGER2:			OnTargetByKey2("VoyagerII");	return true;
		case ID_TARGET_CASSINI:				OnTargetByKey2("Cassini");		return true;
		
		case ID_TARGET_ALP_CEN:				OnTargetByKey2("HIP71683");		return true;
		case ID_TARGET_SIRIUS:				OnTargetByKey2("HIP32349");		return true;
		case ID_TARGET_SUBARU:				OnTargetByKey2("HIP17702");		return true;
		case ID_TARGET_CASTOR:				OnTargetByKey2("HIP36850");		return true;
		
		case ID_TARGET_M13:					OnTargetByKey2("M13");			return true;
		case ID_TARGET_OUR_GALAXY_CENTER:	OnTargetByKey2("OurGalaxy");	return true;
		case ID_TARGET_M31:					OnTargetByKey2("NGC224");		return true;
		case ID_TARGET_VIRGO_CLUSTER:		OnTargetByKey2("NGC4486");		return true;


		//== VIEW ==

		//--  Planet  --
		case ID_PLANET_DISP:			OnDispSwitchToggle(DISPSW_PLANET, DISPM_DISP);			return true;
		case ID_PLANET_NAME:			OnDispSwitchToggle(DISPSW_PLANET, DISPM_NAME);			return true;
		case ID_PLANET_ORBIT:			OnDispSwitchToggle(DISPSW_PLANET, DISPM_ORBIT);			return true;
		case ID_PLANET_AXIS:			OnDispSwitchToggle(DISPSW_PLANET, DISPM_AXIS);			return true;
		case ID_PLANET_CLOUD:			OnDispSwitchToggle(DISPSW_PLANET, DISPM_CLOUD);			return true;
		case ID_PLANET_CITY_LIGHTS:		OnDispSwitchToggle(DISPSW_PLANET, DISPM_CITY_LIGHTS);	return true;
		case ID_PLANET_ATMOSPHERE_NONE:		OnPlanetAtmosphere(ATMOSPHERE_NONE);		return true;
		case ID_PLANET_ATMOSPHERE_SINGLE:	OnPlanetAtmosphere(ATMOSPHERE_SINGLE);		return true;
		case ID_PLANET_ATMOSPHERE_MULTIPLE:	OnPlanetAtmosphere(ATMOSPHERE_MULTIPLE);	return true;
		case ID_PLANET_ZOOM0:			OnZoomMode(0);					return true;
		case ID_PLANET_ZOOM1:			OnZoomMode(1);					return true;
		case ID_PLANET_ZOOM2:			OnZoomMode(2);					return true;
		case ID_PLANET_ZOOM3:			OnZoomMode(3);					return true;
		case ID_PLANET_TOPO0:			OnTopoZoomMode(0);				return true;
		case ID_PLANET_TOPO1:			OnTopoZoomMode(1);				return true;
		case ID_PLANET_TOPO2:			OnTopoZoomMode(2);				return true;
		case ID_PLANET_TOPO3:			OnTopoZoomMode(3);				return true;
		case ID_PLANET_TOPO4:			OnTopoZoomMode(4);				return true;
		//--  Satellites  --
		case ID_SATELLITE_DISP:			OnDispSwitchToggle(DISPSW_SATELLITE, DISPM_DISP);		return true;
		case ID_SATELLITE_NAME:			OnDispSwitchToggle(DISPSW_SATELLITE, DISPM_NAME);		return true;
		case ID_SATELLITE_ORBIT:		OnDispSwitchToggle(DISPSW_SATELLITE, DISPM_ORBIT);		return true;
		case ID_SATELLITE_SELECT:		OnDispSwitchToggle(DISPSW_SATELLITE, DISPM_SELECT);		return true;
		//--  Minor Planets  --
		case ID_MINORPLANET_DISP:		OnDispSwitchToggle(DISPSW_MINOR_PLANET, DISPM_DISP);		return true;
		case ID_MINORPLANET_NAME:		OnDispSwitchToggle(DISPSW_MINOR_PLANET, DISPM_NAME);		return true;
		case ID_MINORPLANET_ORBIT:		OnDispSwitchToggle(DISPSW_MINOR_PLANET, DISPM_ORBIT);		return true;
		case ID_MINORPLANET_SELECT:		OnDispSwitchToggle(DISPSW_MINOR_PLANET, DISPM_SELECT);		return true;
		//--  TNOs  --
		case ID_TNO_DISP:			OnDispSwitchToggle(DISPSW_TNO, DISPM_DISP);			return true;
		case ID_TNO_NAME:			OnDispSwitchToggle(DISPSW_TNO, DISPM_NAME);			return true;
		case ID_TNO_ORBIT:			OnDispSwitchToggle(DISPSW_TNO, DISPM_ORBIT);		return true;
		case ID_TNO_SELECT:			OnDispSwitchToggle(DISPSW_TNO, DISPM_SELECT);		return true;
		case ID_PLANET_OORT_CLOUD:		OnOortCloud(!bOortCloud);		return true;
		case ID_ECLIPSE_DISP:			OnEclipse(swEclipse ^ ECLIPSE_DISP);	return true;
		case ID_ECLIPSE_BORDER:			OnEclipse(swEclipse ^ ECLIPSE_BORDER);	return true;
		//--  Star  --
		case ID_STAR_DISP:			OnStar(swStar ^ STAR_DISP);					return true;
		case ID_STAR_NAME:			OnStar(swStar ^ STAR_NAME);					return true;
		case ID_STAR_NAME_SELECT:	OnStar(swStar ^ STAR_NAME_SELECT);			return true;
		case ID_STAR_BAYER:			OnStar(swStar ^ STAR_BAYER);				return true;
		case ID_STAR_FRAM:			OnStar(swStar ^ STAR_FRAMSTEED);			return true;
		case ID_STAR_HIP:			OnStar(swStar ^ STAR_HIP);					return true;
		case ID_STAR_MARK_NONE:			OnStarMark(0);							return true;
		case ID_STAR_MARK_BINARY:		OnStarMark(1);							return true;
		case ID_STAR_MARK_EXOPLANET:	OnStarMark(2);							return true;
		case ID_STAR_BRIGHTEN:		OnLRef( pow(10, -0.4*0.5) );				return true;
		case ID_STAR_DARKEN:		OnLRef( pow(10, +0.4*0.5) );				return true;
		case ID_STAR_STANDARD:		OnSetLRef( 1.0f );							return true;
		//--  Constellation  --
		case ID_CNST_NAME:		OnConstellation(swConstellation ^ CNST_NAME);		return true;
		case ID_CNST_LINE:		OnConstellation(swConstellation ^ CNST_LINE);		return true;
		case ID_CNST_ILLUST:	OnConstellation(swConstellation ^ CNST_ILLUST);		return true;
		case ID_CNST_BOUNDARY:	OnConstellation(swConstellation ^ CNST_BND);		return true;
		//-- 
		case ID_ORBIT_PIONEER10:	OnSpacecraftPath(0, !get_spacecraft_path_mode(0) );		return true;
		case ID_ORBIT_PIONEER11:	OnSpacecraftPath(1, !get_spacecraft_path_mode(1) );		return true;
		case ID_ORBIT_VOYAGER1:		OnSpacecraftPath(2, !get_spacecraft_path_mode(2) );		return true;
		case ID_ORBIT_VOYAGER2:		OnSpacecraftPath(3, !get_spacecraft_path_mode(3) );		return true;
		case ID_ORBIT_CASSINI:		OnSpacecraftPath(4, !get_spacecraft_path_mode(4) );		return true;
		//--
		case ID_CLST_NONE:				OnMilkyWay(0);		return true;
		case ID_CLST_MILKYWAY:			OnMilkyWay(1);		return true;
		case ID_CLST_MILKYWAY_BRIGHT:	OnMilkyWay(2);		return true;
		case ID_CLST_MILKYWAY_INFRA:	OnMilkyWay(3);		return true;
		//--
		case ID_GALAXY_OUR_GALAXY:		OnGalaxy(swGalaxy ^ GLXY_OUR_GALAXY);		return true;
		case ID_GALAXY_GC:				OnGalaxy(swGalaxy ^ GLXY_GLOB_CLSTR);		return true;
		case ID_GALAXY_NEAR:			OnGalaxy(swGalaxy ^ GLXY_NEARBY_GALAXY);	return true;
		case ID_GALAXY_SDSS:			OnGalaxy(swGalaxy ^ GLXY_DISTANT_GALAXY);	return true;
		case ID_GALAXY_QSO:				OnGalaxy(swGalaxy ^ GLXY_QSO);				return true;
		case ID_MARK_VIRGO_CLUSTER:		OnMarkVirgoCluster(!bVirgoCluster);			return true;
		//--
		case ID_GRID_EQ:				OnCelestialGrid(!bCelestialGrid);			return true;
		case ID_GRID_EC:				OnEcliptic(!bEcliptic);						return true;
		case ID_GRID_GAL:				OnGalacticGrid(!bGalacticGrid);				return true;
		case ID_GRID_HORIZON:			OnHorizonCoord(!bHorizonCoord);				return true;
		case ID_DISTANCE_SCALE:			OnDistScale(swScaleLine ^ SCALE_CIRCLE);	return true;
		case ID_SCALE_SQUARE:			OnDistScale(swScaleLine ^ SCALE_SQUARE);	return true;
		//--
		case ID_PLANET_POINTER:			OnSurfacePointer(!bSurfacePointer);		return true;
		case ID_VIEW_INFO:				OnViewInfo(!bViewInfo);					return true;
		case ID_RESET_VIEW:				OnResetViewangle();						return true;
		case ID_FONT_SIZE_LARGEST:		OnFontSize(0);							return true;
		case ID_FONT_SIZE_LARGER:		OnFontSize(1);							return true;
		case ID_FONT_SIZE_MIDDLE:		OnFontSize(2);							return true;
		case ID_FONT_SIZE_SMALLER:		OnFontSize(3);							return true;
		case ID_FONT_SIZE_SMALLEST:		OnFontSize(4);							return true;
		case ID_VIEW_FULLSCREEN:		OnFullScreen(true);				return true;
		//-- Time
		case ID_TIME_DISP:				OnDate(!bDate);					return true;
		case ID_TIME_SETTING:			OnTimeSetting();				return true;
		case ID_TIME_10SEC:				OnTimeStep(TIMESTEP_10SEC);		return true;
		case ID_TIME_1MIN:				OnTimeStep(TIMESTEP_MIN);		return true;
		case ID_TIME_10MIN:				OnTimeStep(TIMESTEP_10MIN);		return true;
		case ID_TIME_1HOUR:				OnTimeStep(TIMESTEP_HOUR);		return true;
		case ID_TIME_4HOUR:				OnTimeStep(TIMESTEP_4HOUR);		return true;
		case ID_TIME_1DAY:				OnTimeStep(TIMESTEP_DAY);		return true;
		case ID_TIME_1WEEK:				OnTimeStep(TIMESTEP_WEEK);		return true;
		case ID_TIME_1MONTH:			OnTimeStep(TIMESTEP_MONTH);		return true;
		case ID_TIME_1YEAR:				OnTimeStep(TIMESTEP_YEAR);		return true;
		case ID_TIME_10YEAR:			OnTimeStep(TIMESTEP_10YEAR);	return true;
		case ID_TIME_100YEAR:			OnTimeStep(TIMESTEP_100YEAR);	return true;
		case ID_TIME_SET_PRESENT:		OnPresentTime();				return true;
		case ID_TIME_REALTIME_MODE:		OnRealTimeMode(!GetRealtimeMode());		return true;
		//-- Scale
		case ID_SCALE_0:				OnPresetScale(SCALE_1000KM);	return true;
		case ID_SCALE_1:				OnPresetScale(SCALE_1AU);		return true;
		case ID_SCALE_2:				OnPresetScale(SCALE_10AU);		return true;
		case ID_SCALE_3:				OnPresetScale(SCALE_100AU);		return true;
		case ID_SCALE_4:				OnPresetScale(SCALE_1000AU);	return true;
		case ID_SCALE_5:				OnPresetScale(SCALE_10000AU);	return true;
		case ID_SCALE_6:				OnPresetScale(SCALE_1LY);		return true;
		case ID_SCALE_7:				OnPresetScale(SCALE_10LY);		return true;
		case ID_SCALE_8:				OnPresetScale(SCALE_100LY);		return true;
		case ID_SCALE_9:				OnPresetScale(SCALE_1KLY);		return true;
		case ID_SCALE_A:				OnPresetScale(SCALE_10KLY);		return true;
		case ID_SCALE_B:				OnPresetScale(SCALE_100KLY);	return true;
		case ID_SCALE_C:				OnPresetScale(SCALE_1MLY);		return true;
		case ID_SCALE_D:				OnPresetScale(SCALE_10MLY);		return true;
		case ID_SCALE_E:				OnPresetScale(SCALE_100MLY);	return true;
		case ID_SCALE_F:				OnPresetScale(SCALE_1GLY);		return true;
		case ID_SCALE_G:				OnPresetScale(SCALE_10GLY);		return true;
		//-- Settings
		case ID_STEREO_NONE:			OnStereo(STEREO_NONE);				return true;
		case ID_STEREO_ANAGLYPH:		OnStereo(STEREO_ANAGLYPH);			return true;
		case ID_STEREO_COLOR_ANAGLYPH:	OnStereo(STEREO_COLOR_ANAGLYPH);	return true;
		case ID_STEREO_SIDE_BY_SIDE:	OnStereo(STEREO_SIDE_BY_SIDE);		return true;
		case ID_STEREO_ABOVE_BELOW:		OnStereo(STEREO_TOP_AND_BOTTOM);	return true;
		case ID_LANG_JAPANESE:			OnLang(LANG_KNJ);					return true;
		case ID_LANG_JAPANESE_R:		OnLang(LANG_HIRA);					return true;
		case ID_LANG_ENGLISH:			OnLang(LANG_ENG);					return true;
		//-- HELP
		case ID_HELP_ABOUT:				OnAbout();							return true;

		default:											break;
	}
	return false;
}


void
process_menu_checks(WPARAM wParam)
{
	HMENU hmnu = (HMENU)wParam;

	//-- File
	EnableMenuItem( hmnu, ID_FILE_SAVEIMAGE_HIGHRES,	(isPBufferEnable())    ?  MF_ENABLED : MF_GRAYED );
	//-- Landing
	const char ldmd = get_landing_mode();
	CheckMenuItem( hmnu, ID_LANDING_MODE_HORIZONTAL,	(ldmd==LANDING_MODE_HORIZONTAL)    ?  MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_LANDING_MODE_SURFACE_VIEW,	(ldmd==LANDING_MODE_SURFACE_VIEW)  ?  MF_CHECKED : MF_UNCHECKED );
	//-- fE
	CheckMenuItem( hmnu, ID_PLANET_DISP,		test_disp_switch(DISPSW_PLANET, DISPM_DISP)			? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_NAME,		test_disp_switch(DISPSW_PLANET, DISPM_NAME)			? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_ORBIT,		test_disp_switch(DISPSW_PLANET, DISPM_ORBIT)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_AXIS,		test_disp_switch(DISPSW_PLANET, DISPM_AXIS)			? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_CLOUD,		test_disp_switch(DISPSW_PLANET, DISPM_CLOUD)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_CITY_LIGHTS,	test_disp_switch(DISPSW_PLANET, DISPM_CITY_LIGHTS)	? MF_CHECKED : MF_UNCHECKED );

	const char atmd = AtmosphereMode;
	CheckMenuItem( hmnu, ID_PLANET_ATMOSPHERE_NONE,			(atmd==ATMOSPHERE_NONE)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_ATMOSPHERE_SINGLE,		(atmd==ATMOSPHERE_SINGLE)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_ATMOSPHERE_MULTIPLE,		(atmd==ATMOSPHERE_MULTIPLE)	? MF_CHECKED : MF_UNCHECKED );

	const char zmmd = get_zoom_mode();
	CheckMenuItem( hmnu, ID_PLANET_ZOOM0,		(zmmd==0)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_ZOOM1,		(zmmd==1)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_ZOOM2,		(zmmd==2)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_ZOOM3,		(zmmd==3)	? MF_CHECKED : MF_UNCHECKED );

	const char tzmd = get_topo_zoom_mode();
	CheckMenuItem( hmnu, ID_PLANET_TOPO0,		(tzmd==0)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_TOPO1,		(tzmd==1)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_TOPO2,		(tzmd==2)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_TOPO3,		(tzmd==3)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_PLANET_TOPO4,		(tzmd==4)	? MF_CHECKED : MF_UNCHECKED );

	CheckMenuItem( hmnu, ID_PLANET_OORT_CLOUD,		bOortCloud		? MF_CHECKED : MF_UNCHECKED );

	//--  q
	CheckMenuItem( hmnu, ID_SATELLITE_DISP,			test_disp_switch(DISPSW_SATELLITE, DISPM_DISP)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_SATELLITE_NAME,			test_disp_switch(DISPSW_SATELLITE, DISPM_NAME) 		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_SATELLITE_ORBIT,		test_disp_switch(DISPSW_SATELLITE, DISPM_ORBIT)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_SATELLITE_SELECT,		test_disp_switch(DISPSW_SATELLITE, DISPM_SELECT)	? MF_CHECKED : MF_UNCHECKED );

	//--  f
	CheckMenuItem( hmnu, ID_MINORPLANET_DISP,		test_disp_switch(DISPSW_MINOR_PLANET, DISPM_DISP)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_MINORPLANET_NAME,		test_disp_switch(DISPSW_MINOR_PLANET, DISPM_NAME) 	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_MINORPLANET_ORBIT,		test_disp_switch(DISPSW_MINOR_PLANET, DISPM_ORBIT)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_MINORPLANET_SELECT,		test_disp_switch(DISPSW_MINOR_PLANET, DISPM_SELECT)	? MF_CHECKED : MF_UNCHECKED );

	//--  TNO
	CheckMenuItem( hmnu, ID_TNO_DISP,		test_disp_switch(DISPSW_TNO, DISPM_DISP)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TNO_NAME,		test_disp_switch(DISPSW_TNO, DISPM_NAME) 	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TNO_ORBIT,		test_disp_switch(DISPSW_TNO, DISPM_ORBIT)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TNO_SELECT,		test_disp_switch(DISPSW_TNO, DISPM_SELECT)	? MF_CHECKED : MF_UNCHECKED );

	//--
	CheckMenuItem( hmnu, ID_ECLIPSE_DISP,		swEclipse & ECLIPSE_DISP	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_ECLIPSE_BORDER,		swEclipse & ECLIPSE_BORDER	? MF_CHECKED : MF_UNCHECKED );

	//-- P
	CheckMenuItem( hmnu, ID_STAR_DISP,			swStar & STAR_DISP			? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STAR_NAME,			swStar & STAR_NAME			? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STAR_NAME_SELECT,	swStar & STAR_NAME_SELECT	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STAR_BAYER,			swStar & STAR_BAYER			? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STAR_FRAM,			swStar & STAR_FRAMSTEED		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STAR_HIP,			swStar & STAR_HIP			? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STAR_MARK_NONE,			(tyStarMark==0)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STAR_MARK_BINARY,		(tyStarMark==1)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STAR_MARK_EXOPLANET,	(tyStarMark==2)		? MF_CHECKED : MF_UNCHECKED );

	//-- 
	CheckMenuItem( hmnu, ID_CNST_NAME,		swConstellation & CNST_NAME		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_CNST_LINE,		swConstellation & CNST_LINE		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_CNST_ILLUST,	swConstellation & CNST_ILLUST	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_CNST_BOUNDARY,	swConstellation & CNST_BND		? MF_CHECKED : MF_UNCHECKED );

	//-- T@
	CheckMenuItem( hmnu, ID_ORBIT_PIONEER10,	get_spacecraft_path_mode(0)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_ORBIT_PIONEER11,	get_spacecraft_path_mode(1)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_ORBIT_VOYAGER1,		get_spacecraft_path_mode(2)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_ORBIT_VOYAGER2,		get_spacecraft_path_mode(3)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_ORBIT_CASSINI,		get_spacecraft_path_mode(4)		? MF_CHECKED : MF_UNCHECKED );

	//-- V̐
	CheckMenuItem( hmnu, ID_CLST_NONE,				tyMilkyWay==0	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_CLST_MILKYWAY,			tyMilkyWay==1	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_CLST_MILKYWAY_BRIGHT,	tyMilkyWay==2	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_CLST_MILKYWAY_INFRA,	tyMilkyWay==3	? MF_CHECKED : MF_UNCHECKED );

	//-- 
	CheckMenuItem( hmnu, ID_GALAXY_OUR_GALAXY,	swGalaxy & GLXY_OUR_GALAXY		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_GALAXY_GC,			swGalaxy & GLXY_GLOB_CLSTR		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_GALAXY_NEAR,		swGalaxy & GLXY_NEARBY_GALAXY	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_GALAXY_SDSS,		swGalaxy & GLXY_DISTANT_GALAXY	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_GALAXY_QSO,			swGalaxy & GLXY_QSO				? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_MARK_VIRGO_CLUSTER,	bVirgoCluster		? MF_CHECKED : MF_UNCHECKED );

	//-- oܐ
	CheckMenuItem( hmnu, ID_GRID_EQ,			bCelestialGrid	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_GRID_EC,			bEcliptic		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_GRID_GAL,			bGalacticGrid	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_GRID_HORIZON,		bHorizonCoord	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_DISTANCE_SCALE,		swScaleLine & SCALE_CIRCLE	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_SCALE_SQUARE,		swScaleLine & SCALE_SQUARE	? MF_CHECKED : MF_UNCHECKED );

	//--
	CheckMenuItem( hmnu, ID_PLANET_POINTER,		bSurfacePointer	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_VIEW_INFO,			bViewInfo		? MF_CHECKED : MF_UNCHECKED );

	//-- 
	CheckMenuItem( hmnu, ID_TIME_DISP,		bDate								? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_10SEC,		(tyTimeStep == TIMESTEP_10SEC)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_1MIN,		(tyTimeStep == TIMESTEP_MIN)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_10MIN,		(tyTimeStep == TIMESTEP_10MIN)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_1HOUR,		(tyTimeStep == TIMESTEP_HOUR)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_4HOUR,		(tyTimeStep == TIMESTEP_4HOUR)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_1DAY,		(tyTimeStep == TIMESTEP_DAY)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_1WEEK,		(tyTimeStep == TIMESTEP_WEEK)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_1MONTH,	(tyTimeStep == TIMESTEP_MONTH)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_1YEAR,		(tyTimeStep == TIMESTEP_YEAR)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_10YEAR,	(tyTimeStep == TIMESTEP_10YEAR)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_100YEAR,	(tyTimeStep == TIMESTEP_100YEAR)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_TIME_REALTIME_MODE,	GetRealtimeMode()				? MF_CHECKED : MF_UNCHECKED );

	//-- TCY
	CheckMenuItem( hmnu, ID_FONT_SIZE_LARGEST,	(FontSize == vFontSize[0])		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_FONT_SIZE_LARGER,	(FontSize == vFontSize[1])		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_FONT_SIZE_MIDDLE,	(FontSize == vFontSize[2])		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_FONT_SIZE_SMALLER,	(FontSize == vFontSize[3])		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_FONT_SIZE_SMALLEST,	(FontSize == vFontSize[4])		? MF_CHECKED : MF_UNCHECKED );

	//-- ̎
	char ty = get_stereo_mode();
	CheckMenuItem( hmnu, ID_STEREO_NONE,			(ty==STEREO_NONE)			? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STEREO_ANAGLYPH,		(ty==STEREO_ANAGLYPH)		? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STEREO_COLOR_ANAGLYPH,	(ty==STEREO_COLOR_ANAGLYPH)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STEREO_SIDE_BY_SIDE,	(ty==STEREO_SIDE_BY_SIDE)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_STEREO_ABOVE_BELOW,		(ty==STEREO_TOP_AND_BOTTOM)	? MF_CHECKED : MF_UNCHECKED );

	//-- 
	char lang = get_language();
	CheckMenuItem( hmnu, ID_LANG_ENGLISH,		(lang==LANG_ENG)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_LANG_JAPANESE,		(lang==LANG_KNJ)	? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( hmnu, ID_LANG_JAPANESE_R,	(lang==LANG_HIRA)	? MF_CHECKED : MF_UNCHECKED );
}


//---------------------------------
//  Ԑݒp̃|bvAbvEj[
//---------------------------------
void
popup_time_menu(HWND hWnd, short x, short y)
{
	POINT pt;
	pt.x = x;
	pt.y = y;
	ClientToScreen(hWnd, &pt);

	HMENU hmnu = (get_language()==LANG_ENG)  ?  hMenuTimeE  :  hMenuTimeJ;
	TrackPopupMenu(hmnu, TPM_RIGHTBUTTON , pt.x, pt.y, 0, hWnd, NULL);
}


//-------------------------------------
//  XP[ݒp̃|bvAbvEj[
//-------------------------------------
void
popup_scale_menu(HWND hWnd, short x, short y)
{
	POINT pt;
	pt.x = x;
	pt.y = y;
	ClientToScreen(hWnd, &pt);

	HMENU hmnu = (get_language()==LANG_ENG)  ?  hMenuScaleE  :  hMenuScaleJ;
	TrackPopupMenu(hmnu, TPM_RIGHTBUTTON , pt.x, pt.y, 0, hWnd, NULL);
}
