/**************************************************************************************************

Copyright (c) 2014   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_MOVIE2_H__
#define __MTK_MOVIE2_H__
#include  <dshow.h>
#include  <vector>
using namespace std;
#include  "mtk_video.h"
#include  "../common/win_file.h"



enum {
	STATE_NO_MOVIE,
	STATE_PLAYING,
	STATE_PAUSED,
	STATE_STOPPED
};




class mtk_movie
{
public:
	mtk_movie();
	~mtk_movie();

	void	CleanUpGraph();

	HRESULT	Open(const char *fn, HWND hwnd, int x0, int y0, int w, int h, UINT u_WM_NOTIFY, int iRenderer);
	void	Play();
	void	Pause();
	void	Home();
	void	End();
	void	Close();

	LONGLONG	GetPosition() const;
	LONGLONG	GetEndPosition() const;
	void		SetPosition(LONGLONG pos);

	void		GetWindowPosition(int &x, int &y, int &w, int &h) const;

	int	GetState() const;

	HRESULT	OnPaint(HWND hwnd, HDC hdc);
	HRESULT	OnDisplayChange();
	bool	GetEvent(long& evCode, long& prm1, long& prm2);


private:
	IGraphBuilder *m_pGB;
	IMediaControl *m_pMC;
	IMediaEventEx *m_pEv;
	IMediaSeeking *m_pMS;

	mtk_video  *m_pVideo;
	int	m_state;
	LONGLONG m_end_pos;
	int m_w, m_h;	// video size
	int m_x, m_y;	// video position
};





//=======================
//  fBAt@C̊Ǘ
//=======================
const  int media_files_max = 30;	// ő̃t@C


//-----------------------
//  fBAt@C̏
//-----------------------
struct  media_file_info
{
	char	filename[MAX_PATH + 1];	// t@C
	char	filename2[MAX_PATH + 1];	// t@Ci[hpj
	char	type;					// fBA̎
	char	menu_title[256];		// j[p̃^Cg
	char	disp_title[256];		// \p̃^Cg
};

//---------------------
// fBAt@C̎
//---------------------
enum {
	MEDIATYPE_IMAGE,
	MEDIATYPE_POPUP_IMAGE,
	MEDIATYPE_MOVIE,
	MEDIATYPE_AUDIO
};





//----------------------------
//  fBAt@CNX
//----------------------------
class  MediaFiles : public vector<media_file_info>
{
public:
	MediaFiles() {}

	bool	open_info_file(const directory& dir, const char* fn);
	bool	load_pathfile(int idx, char file_path[][MAX_PATH], bool bSubtitlesMode) const;
};




#endif
