/**************************************************************************************************

Copyright (c) 2007-2012   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_solar_system.h"
#include  "mtk_colors.h"
#include  "mtk_sun.h"
#include  "mtk_planets.h"
#include  "mtk_satellites.h"
#include  "mtk_minor_planets.h"
#include  "mtk_oort_cloud.h"
#include  "mtk_label.h"
#include  "mtk_objects.h"
#include  "mtk_object_position.h"
#include  "mtk_time.h"



//-------------
//  Text size
//-------------
static float  ObjectNameSize, SpecialObjectNameSize;

//---------
//  Orbit
//---------
static float OrbitWidth;

//-------------
//  Zoom mode
//-------------
const zoom_rate ZoomRate[4] = {
	{   1,  1,  1,   1,  1},
	{ 500,  1, 25,  20,  1},
	{1000, 25, 50, 100,  5},
	{1500, 50, 70, 200, 10}
};

static char ZoomMode = 0;


//------------
//  Lighting
//------------
static float LightingAmbient;
float LightingAmbientDef = 0.1;


void	set_side_light(const mtk_draw_struct& ds);



//-----------------
//  Load textures
//-----------------
void
load_solar_system_textures()
{
	//-- Sun
	load_sun_textures();

	//-- Planets
	load_planets_textures();

	//-- Satellite
	load_satellites_textures();
}



//---------------
//  Orientation
//---------------

//-- WnV̍Wnֈڂ
void
set_object_orientation(const matrix3d& MT)
{
	float M[16];

	M[0] = MT.m11;
	M[1] = MT.m21;
	M[2] = MT.m31;
	M[3] = 0.0;

	M[4] = MT.m12;
	M[5] = MT.m22;
	M[6] = MT.m32;
	M[7] = 0.0;

	M[8] = MT.m13;
	M[9] = MT.m23;
	M[10]= MT.m33;
	M[11] = 0.0;

	M[12] = 0.0;
	M[13] = 0.0;
	M[14] = 0.0;
	M[15] = 1.0;

	glMultMatrixf(M);
}




//-------------
//  Zoom rate
//-------------
zoom_rate
get_zoom_rate()
{
	return ZoomRate[ZoomMode];
}

void
set_zoom_mode(char mode)
{
	ZoomMode = mode;
	const double  t = get_time_JD();
	update_objects_position_and_orientation(t, true);
	update_space_curves(t);
}

char
get_zoom_mode()
{
	return ZoomMode;
}




//-------------
//  Text size
//-------------
float
get_object_name_size()
{
	return  ObjectNameSize;
}

float
get_special_object_name_size()
{
	return  SpecialObjectNameSize;
}

void
set_object_name_size(float sz)
{
	ObjectNameSize = sz;
}

void
set_special_object_name_size(float sz)
{
	SpecialObjectNameSize = sz;
}


//---------
//  Orbit
//---------
float
get_orbit_width()
{
	return  OrbitWidth;
}

void
set_orbit_width(float w)
{
	OrbitWidth = w;
}


//------------
//  Lighting
//------------
float
get_lighting_ambient()
{
	return  LightingAmbient;
}

void
set_lighting_ambient(float amb)
{
	LightingAmbient = amb;
}




//--------
//  Draw
//--------
void
draw_celestial_object(float Rx, float Ry, float Rz)
{
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	glEnable(GL_LIGHTING);
	glEnable(GL_BLEND);
	glPushMatrix();
		glScalef(Rx, Ry, Rz);
		glEnable(GL_CULL_FACE);
		gl_draw_LOD_sphere();
	glPopMatrix();
}





