/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef  __MTK_SPACECRAFT_MODEL_H__
#define  __MTK_SPACECRAFT_MODEL_H__
#include  <windows.h>
#include  <gl/gl.h>
#include  <vector>
#include  "../common/math/vector3.h"
#include  "../common/graphics/color.h"
#include  "../common/graphics/gl_Model3D.h"
#include  "../common/graphics/wgl_font.h"
#include  "mtk_draw_struct.h"
using namespace std;




struct spacecraft_path_data
{
	double		t;
	vector3d	pos;
};


class spacecraft
{
	vector<spacecraft_path_data>  path;		// path
	glModel3D*	pModel;
	bilingual	bszName;					// name
	bool		bDrawPath;

public:
	spacecraft() : path(0), pModel(0), bDrawPath(false)  {};

	bool		is_available_time(const double& t) const;
	double		get_t1() const;
	double		get_t2() const;
	vector3d	get_pos(const double& t) const;

	//-- Path
	bool		load_path(const char *filename);
	void		draw_path(const mtk_draw_struct& ds, const double& t, const vector3d& target_r, const RGBf& col, float af) const;
	void		set_draw_path_mode(bool bFlg)	{ bDrawPath = bFlg; }
	bool		get_draw_path_mode() const		{ return bDrawPath; }

	//-- Model
	void		set_model(glModel3D* _pModel) { pModel = _pModel; }
	void		draw_model() const;

	//-- Laebl
	void		set_name(const bilingual& name) { bszName = name; }
	void		draw_label(wgl_font& fnt, bool bEng) const;
	const bilingual&	get_name() const { return bszName; }

	//--
	void		set(const char* name_E, const char* name_J, glModel3D* _pModel);
};




#endif
